# -*- Mode: Python -*-
# -*- coding: utf-8 -*-
# vi:si:et:sw=4:sts=4:ts=4

from codeina.installer import InterfaceInstaller
from codeina.extern.log import log
from gettext import gettext as _
import os
import tempfile

class Installer(InterfaceInstaller):

    def __init__ (self):
        import popen2
        fin, fout = popen2.popen2("dpkg -l | awk '{ print $2}'")
        self.installed_packages = fin.readlines ()

    def is_installed(self, package):
        return package.nick in [p.strip () for p in self.installed_packages]

    def _create_selections_file (self, list):
        f = tempfile.NamedTemporaryFile ()
        for pkg in list:
            f.write ('%s\tinstall\n' % pkg.nick)
        f.flush ()
        return f

    def _launch_synaptic (self, list):
        f = self._create_selections_file (list)
        command = ["gksu", "--", "/usr/sbin/synaptic", "--hide-main-window",
                    "--non-interactive", "--finish-str", _('"Missing codecs installed"'),
                    "--set-selections-file", f.name]
        import subprocess
        subprocess.call (command)
        f.close ()

    def install(self,package):
        self._launch_synaptic ([package])

    def install_list (self, list):
        self._launch_synaptic (list)
